/**
 * ʓI sqobject 
 * 
 * Object, Thread ̓o^̎łB
 * Thread ͌psŁAObject ͌pΏۂׂăXgǗđΉĂ܂B
 */
#include <new>
#include "sqobjectinfo.h"
#include "sqobject.h"
#include "sqthread.h"

#include <string.h>
#include <sqstdstring.h>
#include <sqstdmath.h>
#include <sqstdaux.h>

SQRESULT ERROR_CREATE(HSQUIRRELVM v) {
	return sq_throwerror(v, _SC("can't create native instance"));
}

SQRESULT ERROR_BADINSTANCE(HSQUIRRELVM v) {
	return sq_throwerror(v, _SC("bad instance"));
}

SQRESULT ERROR_BADMETHOD(HSQUIRRELVM v) {
	return sq_throwerror(v, _SC("bad method"));
}

// NX_~[p
struct BaseClass {};
inline const SQChar *GetTypeName(const BaseClass *t) { return NULL; }

// NXo^p
#define DECLARE_CLASSNAME(TYPE,NAME) \
inline const SQChar * GetTypeName(const TYPE *t) { return NAME; }
#define DECLARE_CLASS(TYPE) DECLARE_CLASSNAME(TYPE,_SC(#TYPE))

sqobject::ObjectInfo typeTagListMap;
sqobject::ObjectInfo typeMap;

/**
 * p֌Wo^
 * @param typeName ^
 * @param parentName ě^
 */
void
registerInherit(const SQChar *typeName, const SQChar *parentName)
{
	typeMap.create(typeName, parentName);
}

/**
 * ě^Ԃ
 * @param typeName ^
 * @return ě^
 */
const SQChar *
getParentName(const SQChar *typeName)
{
	const SQChar *parent = NULL;
	typeMap.get(typeName, &parent);
	return parent;
}

/**
 * IuWFNg̃^Oo^BeIuWFNgɂċAIɓo^B
 * @param typeName ^
 * @parma tag ^O
 */
void
registerTypeTag(const SQChar *typeName, SQUserPointer tag)
{
	// ^Oo^
	sqobject::ObjectInfo list = typeTagListMap.get(typeName);
	if (!list.isArray()) {
		list.initArray();
		typeTagListMap.create(typeName, list);
	}
	list.append(tag);

	// eNXɂo^
	const SQChar *pname = getParentName(typeName);
	if (pname) {
		registerTypeTag(pname, tag);
	}
}

/**
 * YIuWFNg̃lCeBuCX^X擾Bo^Ă^OXgg
 * @param v squirrelVM
 * @param idx X^bNCfbNX
 * @param typeName ^
 * @return w肳ꂽ^̃lCeBuCX^XB݂Ȃꍇ NULL
 */
SQUserPointer
getInstance(HSQUIRRELVM v, int idx, const SQChar *typeName)
{
	sqobject::ObjectInfo list = typeTagListMap.get(typeName);
	if (list.isArray()) {
		int max = list.len();
		for (int i=0;i<max;i++) {
			SQUserPointer tag;
			list.get(i, &tag);
			SQUserPointer up;
			if (SQ_SUCCEEDED(sq_getinstanceup(v, idx, &up, tag))) {
				return up;
			}
		}
	}
	return NULL;
}

/**
 * NXo^pev[g
 * @param T o^Ώی^
 * @param P ě^
 */
template <typename T, typename P>
class SQTemplate {

private:
	HSQUIRRELVM v;
	
public:
	/**
	 * NX`
	 * @param v squirrelVM
	 * @param typetag ^ʃ^O
	 */
	SQTemplate(HSQUIRRELVM v, SQUserPointer typetag) : v(v) {

		// ^ DECLARE_CLASSNAME ̓o^ĎQ
		T* typeDummy = NULL;
		P* parentDummy = NULL;
		const SQChar *typeName = GetTypeName(typeDummy);
		const SQChar *parentName = GetTypeName(parentDummy);
		
		sq_pushstring(v, typeName, -1);
		if (parentName) {
			// eNXw肳Ăꍇ͌p
			::registerInherit(typeName, parentName);
			sq_pushstring(v, parentName, -1);
			if (SQ_SUCCEEDED(sq_get(v,-3))) {
				sq_newclass(v, true);
			} else {
				sq_newclass(v, false);
			}
		} else {
			// pȂŃNX
			sq_newclass(v, false);
		}
		// ^Oo^
		sq_settypetag(v, -1, typetag);
		::registerTypeTag(typeName, typetag);
		
		// RXgN^o^
		Register(constructor, _SC("constructor"));
	}
	
	/*
	 * lCeBuIuWFNg̃[TB
	 */
	static SQRESULT release(SQUserPointer up, SQInteger size) {
		if (up) {
			T* self = (T*)up;
			self->~T();
			sq_free(up, size);
		}
		return SQ_OK;
	}
	
	/**
	 * RXgN^
	 * lCeBuIuWFNg̃RXgN^ɈƂ HSQUIRRELVM nB
	 */
	static SQRESULT constructor(HSQUIRRELVM v) {
		T *self = (T*)sq_malloc(sizeof *self);
		new (self) T(v);
		if (self) {
			SQRESULT result;
			if (SQ_SUCCEEDED(result = sq_setinstanceup(v, 1, self))) {;
				sq_setreleasehook(v, 1, release);
			} else {
				self->~T();
				sq_free(self, sizeof *self);
			}
			return result;
		} else {
			return ERROR_CREATE(v);
		}
	}

	// -------------------------------------------------
	// X^eBbN֐̓o^
	// -------------------------------------------------

	// SQFUNCTION o^
	void Register(SQFUNCTION func, const SQChar *name) {
		sq_pushstring(v, name, -1);
		sq_newclosure(v, func, 0);
		sq_createslot(v, -3);
	}

	// -------------------------------------------------
	// o֐̓o^p
	// -------------------------------------------------

	// CX^X擾
	static T *getInstance(HSQUIRRELVM v, int idx=1) {
		const T *dummy = NULL;
		return static_cast<T*>(::getInstance(v,idx,GetTypeName(dummy)));
	}
	
	// ֐|C^擾
	template <typename Func>
	static void getFunc(HSQUIRRELVM v, Func **func) {
		SQUserPointer x = NULL;
		sq_getuserdata(v,sq_gettop(v),&x,NULL);
		*func = (Func*)x;
	}

	// -------------------------------------------------

	// Al int ň̊֐
	typedef void (T::*VoidFunc)();

	// IntFunc Ăяo
	static SQRESULT VoidFuncCaller(HSQUIRRELVM v) {
		T *instance = getInstance(v);
		if (instance) {
			VoidFunc *func;
			getFunc(v, &func);
			if (func) {
				(instance->*(*func))();
				return 0;
			}
			return ERROR_BADMETHOD(v);
		}
		return ERROR_BADINSTANCE(v);
	}

	// VoidFunc o^
	void Register(VoidFunc func, const SQChar *name) {
		sq_pushstring(v, name, -1);
		SQUserPointer up = sq_newuserdata(v,sizeof(func));
		memcpy(up,&func,sizeof(func));
		sq_newclosure(v,VoidFuncCaller,1);
		sq_createslot(v, -3);
	}

	// -------------------------------------------------
	
	// Al int ň̊֐
	typedef int (T::*IntFunc)();

	// IntFunc Ăяo
	static SQRESULT IntFuncCaller(HSQUIRRELVM v) {
		T *instance = getInstance(v);
		if (instance) {
			IntFunc *func;
			getFunc(v, &func);
			if (func) {
				sq_pushinteger(v, (instance->*(*func))());
				return 1;
			}
			return ERROR_BADMETHOD(v);
		}
		return ERROR_BADINSTANCE(v);
	}

	// IntFunc o^
	void Register(IntFunc func, const SQChar *name) {
		sq_pushstring(v, name, -1);
		SQUserPointer up = sq_newuserdata(v,sizeof(func));
		memcpy(up,&func,sizeof(func));
		sq_newclosure(v,IntFuncCaller,1);
		sq_createslot(v, -3);
	}

	// -------------------------------------------------

	// SQFUNCTION X^C̊֐
	typedef SQRESULT (T::*VFunc)(HSQUIRRELVM v);

	// VFunc Ăяo
	static SQRESULT VFuncCaller(HSQUIRRELVM v) {
		T *instance = getInstance(v);
		if (instance) {
			VFunc *func = NULL;
			getFunc(v, &func);
			if (func) {
				return (instance->*(*func))(v);
			}
			return ERROR_BADMETHOD(v);
		}
		return ERROR_BADINSTANCE(v);
	}

	// VFunc o^
	void RegisterV(VFunc func, const SQChar *name) {
		sq_pushstring(v, name, -1);
		SQUserPointer up = sq_newuserdata(v,sizeof(func));
		memcpy(up,&func,sizeof(func));
		sq_newclosure(v,VFuncCaller,1);
		sq_createslot(v, -3);
	}
};

namespace sqobject {

// typetag S\[XŃj[NȃAhXɂKv
const SQUserPointer OBJECTTYPETAG = (SQUserPointer)"OBJECTTYPETAG";
const SQUserPointer THREADTYPETAG = (SQUserPointer)"THREADTYPETAG";

// NX`

DECLARE_CLASSNAME(Object, SQOBJECTNAME);
DECLARE_CLASSNAME(Thread, SQTHREADNAME);

// global vm
HSQUIRRELVM vm;

/// vm 
HSQUIRRELVM init() {
	vm = sq_open(1024);
	sq_pushroottable(vm);
	sqstd_register_mathlib(vm);
	sqstd_register_stringlib(vm);
	sqstd_seterrorhandlers(vm);
	sq_pop(vm,1);
	typeMap.initTable();
	typeTagListMap.initTable();
	return vm;
}

/// ێpO[oVM̎擾
HSQUIRRELVM getGlobalVM()
{
	return vm;
}

/// vm I
void done()
{
	// [ge[uNA
	sq_pushroottable(vm);
	sq_clear(vm,-1);
	sq_pop(vm,1);
	typeTagListMap.clearData();
	typeTagListMap.clear();
	typeMap.clearData();
	typeMap.clear();
	sq_close(vm);
}

// Thread ̃CX^X[U|C^擾
Thread *
ObjectInfo::getThread()
{
	HSQUIRRELVM gv = getGlobalVM();
	push(gv);
	Thread *ret = NULL;
	ret = (Thread*)::getInstance(gv, -1, GetTypeName(ret));
	sq_pop(gv,1);
	return ret;
}

// Object ̃CX^X[U|C^擾
Object *
ObjectInfo::getObject()
{
	HSQUIRRELVM gv = getGlobalVM();
	push(gv);
	Object *ret = NULL;
	ret = (Object*)::getInstance(gv, -1, GetTypeName(ret));
	sq_pop(gv,1);
	return ret;
}

// ------------------------------------------------------------------
// NXo^p}N
// ------------------------------------------------------------------

#define SQCLASS(Class,Parent,typetag) SQTemplate<Class,Parent> cls(v,typetag)
#define SQFUNC(Class, Name)   cls.Register(&Class::Name, _SC(#Name))
#define SQVFUNC(Class, Name)  cls.RegisterV(&Class::Name, _SC(#Name))

/**
 * NX̓o^
 * @param v squirrel VM
 */
void
Object::registerClass()
{
	HSQUIRRELVM v = getGlobalVM();
	sq_pushroottable(v); // root

	SQCLASS(Object,BaseClass,OBJECTTYPETAG);

	SQFUNC(Object,notify);
	SQFUNC(Object,notifyAll);
	SQVFUNC(Object,hasSetProp);
	SQVFUNC(Object,setDelegate);
	SQVFUNC(Object,getDelegate);
	SQVFUNC(Object,_get);
	SQVFUNC(Object,_set);
	cls.RegisterV(&Object::_get, _SC("get"));
	cls.RegisterV(&Object::_set, _SC("set"));

	sq_createslot(v, -3); // NXo^
	sq_pop(v,1); // root
};

/**
 * NX̓o^
 * @param v squirrel VM
 */
void
Thread::registerClass()
{
	HSQUIRRELVM v = getGlobalVM();
	sq_pushroottable(v); // root

	SQCLASS(Thread, Object, THREADTYPETAG);

	SQVFUNC(Thread,exec);
	SQVFUNC(Thread,exit);
	SQFUNC(Thread,stop);
	SQFUNC(Thread,run);
	SQFUNC(Thread,getCurrentTick);
	SQFUNC(Thread,getStatus);
	SQVFUNC(Thread,getExitCode);
	SQVFUNC(Thread,wait);
	SQFUNC(Thread,cancelWait);

	sq_createslot(v, -3);
	sq_pop(v, 1); // root
};

}

