#include <new>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <squirrel.h>
#include <AS3.h>

// sqwrapper.cpp 
extern void trace(const char *format, ...);
extern AS3_Val getVal(AS3_Val obj, const char *name);
extern int getInt(AS3_Val obj, const char *name);
extern char *getStr(AS3_Val obj, const char *name);
extern AS3_Val createInstance(const char *nsName, const char *className, AS3_Val args=NULL);

/**
 * t@Cǂݍݗpf[^\
 */
class SQFileInfo {

public:
	SQFileInfo() : loader(NULL), buffer(NULL), size(0) {
	}

	/// RXgN^
	SQFileInfo(const SQChar *filename) : loader(NULL), buffer(NULL), size(0) {
		// NGXg𐶐
		AS3_Val request = createInstance("flash.net", "URLRequest", AS3_Array("StrType", filename));
		if (request) {
			// [_𐶐
			loader = createInstance("flash.net", "URLLoader", AS3_Array("AS3ValType", request));
			AS3_Release(request);
		}
	}

	/// fXgN^
	~SQFileInfo() {
		if (buffer) {
			free(buffer);
		}
		if (loader) {
			AS3_Release(loader);
		}
	}

	/// @return ǂݍ݊ true
	bool check() {
		if (loader) {
			AS3_Val data = getVal(loader, "data");
			if (!data) {
				// ܂ǂݍ݊ĂȂ
				return false;
			}
			char *format = getStr(loader, "dataFormat");
			if (strcmp(format, "binary") == 0) {
				// oCi
				size = getInt(loader, "bytesTotal");
				buffer = (char*)malloc(size);
				AS3_ByteArray_readBytes(buffer, data, size);
			} else if (strcmp(format, "text") == 0) {
				// eLXg
				buffer = AS3_StringValue(data);
				if (buffer) {
					size = strlen(buffer);
				}
			} else {
				// ȊO͖
				trace("not binary/text data");
			}
			free(format);
			AS3_Release(data);
		}
		return true;
	}

	/// @return obt@
	const char *getBuffer() {
		return (const char*)buffer;
	}

	/// @return TCY
	int getSize() {
		return (int)size;
	}

private:
	AS3_Val loader; ///< URLLoader
	char *buffer; ///< ̓f[^̃obt@
	int size;   ///< ǂݍ݃TCY
};

/**
 * t@C񓯊ɊJ
 * @param filename XNvgt@C
 * @return t@Cnh
 */
void *sqobjOpenFile(const SQChar *filename)
{
	//printf("openFile:%s\n", filename);
	SQFileInfo *info = (SQFileInfo*)sq_malloc(sizeof *info);
	new (info) SQFileInfo(filename);
	return (void*)info;
}

/**
 * t@CJꂽǂ̃`FbN
 * @param handler t@Cnh
 * @param dataPtr f[^i[AhX(o)
 * @param dataSize f[^TCY(o)
 * @return [hĂ true
 */
bool sqobjCheckFile(void *handler, const char **dataAddr, int *dataSize)
{
	SQFileInfo *file = (SQFileInfo*)handler;
	if (file) {
		if (file->check()) {
			//printf("checkFileDone\n");
			*dataAddr = file->getBuffer();
			*dataSize = file->getSize();
			return true;
		} else {
			return false;
		}
	} else {
		*dataAddr = NULL;
		*dataSize = 0;
		return true;
	}
}

/**
 * t@C
 * @param handler t@Cnh
 */
void sqobjCloseFile(void *handler)
{
	SQFileInfo *file = (SQFileInfo*)handler;
	if (file) {
		file->~SQFileInfo();
		sq_free(file, sizeof *file);
	}
}
