#include <new>
#include <stdio.h>
#include <stddef.h>
#include <stdarg.h>
#include <string.h>
#include <squirrel.h>
#include <AS3.h>

void sq_pushas3(HSQUIRRELVM v, AS3_Val val); ///< i[p
SQRESULT sq_getas3(HSQUIRRELVM v, int idx, AS3_Val *result); ///< 擾p

// ----------------------------------------------------------------
// AS3 RrjGg\bh
// ----------------------------------------------------------------

/**
 * Flashg[XOo͗p
 */
void trace(const char *format, ...)
{
	va_list args;
	va_start(args, format);
	char msg[1024];
	vsnprintf(msg, sizeof msg-1, format, args);
	AS3_Val m = AS3_String(msg);
	AS3_Trace(m);
	AS3_Release(m);
	va_end(args);
}

/**
 * AS3l擾
 * @param obj ΏƃIuWFNg
 * @param o
 * @return o̒lintŕԂ
 */
AS3_Val getVal(AS3_Val obj, const char *name)
{
	return AS3_GetS(obj, name);
}

/**
 * AS3lݒ
 * @param obj ΏƃIuWFNg
 * @param o
 * @param value ݒl
 */
void setVal(AS3_Val obj, const char *name, AS3_Val value)
{
	AS3_SetS(obj, name, value);
}

/**
 * AS3l擾
 * @param obj ΏƃIuWFNg
 * @param o
 * @return o̒lintŕԂ
 */
int getInt(AS3_Val obj, const char *name)
{
	int ret = 0;
	AS3_Val value = AS3_GetS(obj, name);
	if (value) {
		ret = AS3_IntValue(value);
		AS3_Release(value);
	}
	return ret;
}

/**
 * AS3lݒ
 * @param obj ΏƃIuWFNg
 * @param o
 * @param value ݒl
 */
void setInt(AS3_Val obj, const char *name, int value)
{
	AS3_Val v = AS3_Int(value);
	AS3_SetS(obj, name, v);
	AS3_Release(v);
}

/**
 * AS3l擾
 * @param obj ΏƃIuWFNg
 * @param o
 * @return o̒lchar*ŕԂ
 */
char *getStr(AS3_Val obj, const char *name)
{
	char *ret = 0;
	AS3_Val value = AS3_GetS(obj, name);
	if (value) {
		ret = AS3_StringValue(value);
		AS3_Release(value);
	}
	return ret;
}

/**
 * AS3lݒ
 * @param obj ΏƃIuWFNg
 * @param o
 * @param value ݒl
 */
void setStr(AS3_Val obj, const char *name, const char *value)
{
	AS3_Val v = AS3_String(value);
	AS3_SetS(obj, name, v);
	AS3_Release(v);
}


/**
 * AS3NX
 * @param namespace l[Xy[Xw
 * @param className NX
 */
AS3_Val
createClass(const char *nsName, const char *className)
{
	//trace("createClass:%s cn:%s", nsName, className);
	AS3_Val ns       = AS3_String(nsName);
	AS3_Val classObj = AS3_NSGetS(ns, className);
	AS3_Release(ns);
	return classObj;
}


/**
 * AS3IuWFNg
 * @param namespace l[Xy[Xw
 * @param className NX
 * @param args RXgN^ ̂Œ
 */
AS3_Val
createInstance(const char *nsName, const char *className, AS3_Val args=NULL)
{
	AS3_Val ret;
	AS3_Val classObj = createClass(nsName, className);
	if (classObj) {
		//trace("class %s found", className);
		if (args == NULL) {
			args = AS3_Array("");
		}
		ret = AS3_New(classObj, args);
		AS3_Release(args);
		AS3_Release(classObj);
		if (!ret) {
			trace("new %s failed", className);
		}
	} else {
		trace("class %s not found", className);
		ret = AS3_Null();
	}
	return ret;
}

/**
 * AS3O[ot@NVĂяo
 * @param namespace l[Xy[Xw
 * @param funcName t@NV
 * @param args  ̂Œ
 */
AS3_Val
callFunction(const char *nsName, const char *funcName, AS3_Val args=NULL)
{
	AS3_Val ns = AS3_String(nsName);
	AS3_Val obj = AS3_NSGetS(ns, funcName);
	AS3_Release(ns);
	if (args == NULL) {
		args = AS3_Array("");
	}
	AS3_Val ret = AS3_Call(obj, NULL, args);
	AS3_Release(obj);
	AS3_Release(args);
	return ret;
}


AS3_Val
callMethod(AS3_Val obj, const char *methodName, AS3_Val args=NULL)
{
	if (args == NULL) {
		args = AS3_Array("");
	}
	AS3_Val ret = AS3_CallS(methodName, obj, args);
	AS3_Release(args);
	return ret;
}


/**
 * AS3pXg̐
 * @param vm Squirrel VM
 * @param idx w肵indexXg
 * @return AS3Xg̎
 */
AS3_Val
createArgs(HSQUIRRELVM v, int idx)
{
	int max = sq_gettop(v);
	//trace("createArgs:%d/%d", idx, max);
	AS3_Val array = AS3_Array("");
	for (int i=idx;i<=max;i++) {
		AS3_Val p;
		sq_getas3(v, i, &p);
		AS3_Release(callMethod(array, "push", AS3_Array("AS3ValType", p)));
	}
	//trace("arg length:%d", getInt(array, "length"));
	return array;
}

// ---------------------------------------------------------------------------

// ActionScript Object ʗp
static const SQUserPointer AS3_OBJ_TAG = (SQUserPointer)"AS3_OBJ_TAG";

/**
 * X^bNIuWFNg擾
 * @param v VM
 * @param idx X^bÑCfbNX
 * @param result IuWFNgԂ
 */
SQRESULT
sq_getas3(HSQUIRRELVM v, int idx, AS3_Val *result)
{
	switch (sq_gettype(v,idx)) {
	case OT_INTEGER:
		{
			int val;
			sq_getinteger(v, idx, &val);
			*result = AS3_Int(val);
		}
		break;
	case OT_FLOAT:
		{
			float val;
			sq_getfloat(v, idx, &val);
			*result = AS3_Number((double)val);
		}
		break;
	case OT_BOOL:
		{
			SQBool val;
			sq_getbool(v, idx, &val);
			*result = val ? AS3_True() : AS3_False();
		}
		break;
	case OT_STRING:
		{
			const SQChar *val;
			sq_getstring(v, idx, &val);
			*result = AS3_String(val);
		}
		break;
	case OT_USERDATA:
		{
			SQUserPointer otag;
			SQUserPointer up;
			//trace("from userdata");
			if (SQ_SUCCEEDED(sq_getuserdata(v,idx,&up,&otag)) && otag == AS3_OBJ_TAG) {
				*result = *((AS3_Val*)up);
				AS3_Acquire(*result);
			} else {
				*result = AS3_Null();
			}
		}
		break;
	default:
		*result = AS3_Null();
		break;
	}
	return SQ_OK;
}

//----------------------------------------------------------------------------
// ActionScript3 ̃IuWFNg UserData Ƃĕێ邽߂̋@\
//----------------------------------------------------------------------------

/**
 * IuWFNg
 */
static SQInteger
objRelease(SQUserPointer up, SQInteger size)
{
	AS3_Val obj = *((AS3_Val*)up);
	AS3_Release(obj);
	return 1;
}

/**
 * Objective-C p getter
 * @param v squirrel VM
 */
static SQInteger
get(HSQUIRRELVM v)
{
	AS3_Val obj;
	sq_getas3(v, 1, &obj);

	const SQChar *methodName;
	sq_getstring(v, 2, &methodName);
	//trace("call get:%s", methodName);
	AS3_Val ret = AS3_GetS(obj, methodName);
	AS3_Release(obj);
	if (ret) {
		sq_pushas3(v, ret);
		AS3_Release(ret);
		//trace("done get");
		return 1;
	}
	// o
	trace("nosuch member:%s", methodName);
	return 0;
}

/**
 * Objective-C p setter
 * @param v squirrel VM
 */
static SQInteger
set(HSQUIRRELVM v)
{
	AS3_Val obj; 
	sq_getas3(v, 1, &obj);
	const SQChar *methodName;
	sq_getstring(v, 2, &methodName);
	//trace("call set:%s", methodName);
	AS3_Val value;
	sq_getas3(v, 3, &value);
	AS3_Val ret = AS3_SetS(obj, methodName, value);
	AS3_Release(ret);
	AS3_Release(value);
	AS3_Release(obj);
	//trace("done set");
	return 0;
}

/**
 * Objective-C p\bh܂̓RXgN^̌Ăяo
 * @param v squirrel VM
 */
static SQInteger
call(HSQUIRRELVM v)
{
	// param1 callΏ
	// param2 this
	// param3 ` {̈

	//trace("start call");
	
	AS3_Val func;
	sq_getas3(v, 1, &func);
	if (func) {
		AS3_Malloced_Str type = AS3_TypeOf(func);
		//trace("call arg1type:%s", type);
		if (!strcmp(type, "function")) { // ֐Ăяo
			//trace("call function -----");
			AS3_Val self;
			sq_getas3(v,2,&self);
			AS3_Malloced_Str t2 = AS3_TypeOf(self);
			//trace("call targettype:%s", t2);
			free(t2);
			if (self) { // this
				//trace("call function");
				AS3_Val args = createArgs(v, 3);
				AS3_Val ret = AS3_Call(func, self, args);
				AS3_Release(args);
				AS3_Release(self);
				free(type);
				AS3_Release(func);
				if (ret) {
					sq_pushas3(v, ret);
					AS3_Release(ret);
					//trace("done function -----");
					return 1;
				} else {
					//trace("done function -----");
					return 0;
				}
			} else {
				//trace("self is null and no call function");
				free(type);
				AS3_Release(func);
				//trace("done function -----");
			}
		} else if (!strcmp(type, "object")) { // RXgN^Ăяo
			AS3_Val args = createArgs(v, 3);
			AS3_Val ret = AS3_New(func, args);
			AS3_Release(args);
			free(type);
			AS3_Release(func);
			if (ret) {
				sq_pushas3(v, ret);
				AS3_Release(ret);
				return 1;
			} else {
				return 0;
			}
		}
		free(type);
		AS3_Release(func);
	}
	// ĂяołȂ
	return sq_throwerror(v, "invalid call");
}

/**
 * ActionScript3 IuWFNgX^bNɊi[
 * @param v squirrel VM
 * @param obj Objective-C IuWFNg
 */
void
sq_pushas3(HSQUIRRELVM v, AS3_Val obj)
{
	if (obj == NULL) {
		//trace("push null");
		sq_pushnull(v);
		return;
	}

	AS3_Malloced_Str type = AS3_TypeOf(obj);
	//trace("push data type:%s", type);
	if (!strcmp(type, "null")) {
		//trace("push null");
		sq_pushnull(v);
	} else if (!strcmp(type, "boolean")) {
		//trace("push bool");
		sq_pushbool(v, AS3_IntValue(obj) != 0);
	} else if (!strcmp(type, "number")) {
		//trace("push num");
		sq_pushfloat(v, (SQFloat)AS3_NumberValue(obj));
	} else if (!strcmp(type, "string")) {
		//trace("push string");
		AS3_Malloced_Str str = AS3_StringValue(obj);
		sq_pushstring(v, str, -1);
		free(str);
	} else {
		//trace("push object!");
		
		AS3_Acquire(obj);
		SQUserPointer up = sq_newuserdata(v, sizeof(AS3_Val));
		*((AS3_Val*)up) = obj;

		// ^Oo^
		sq_settypetag(v, -1, AS3_OBJ_TAG);
		
		// JWbNǉ
		sq_setreleasehook(v, -1, objRelease);
		
		// \bhQǉ
		sq_newtable(v);
		
		sq_pushstring(v, "_get", -1);
		sq_newclosure(v, get, 0);
		sq_createslot(v, -3);

		sq_pushstring(v, "_set", -1);
		sq_newclosure(v, set, 0);
		sq_createslot(v, -3);

		sq_pushstring(v, "_call", -1);
		sq_newclosure(v, call, 0);
		sq_createslot(v, -3);
		
		sq_setdelegate(v, -2);
	}
	free(type);
}

